diff -r f12c11450b7f qpy/QtQml/qpyqmlobject.cpp
--- a/qpy/QtQml/qpyqmlobject.cpp	Wed Feb 15 10:25:45 2017 +0000
+++ b/qpy/QtQml/qpyqmlobject.cpp	Thu Feb 16 16:52:48 2017 +0000
@@ -96,6 +96,13 @@
     // Note that we used to use sender() but this proved unreliable.
     if (call == QMetaObject::InvokeMetaMethod && proxied_mo->method(idx).methodType() == QMetaMethod::Signal)
     {
+        // Get the meta-object of the class that defines the signal.
+        while (idx < proxied_mo->methodOffset())
+        {
+            proxied_mo = proxied_mo->superClass();
+            Q_ASSERT(proxied_mo);
+        }
+
         // Relay the signal to QML.
         QMetaObject::activate(this, proxied_mo,
                 idx - proxied_mo->methodOffset(), args);
